<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>task 32.50v </title>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js"></script>
</head>

<body>
    <div class="jumbotron text-center">
        <h1>Danh sách người dùng đăng ký </h1>
        <div class="row">
            <div class="col-sm-1">
                <button id="add-user" class="btn btn-success">Thêm user</button>
            </div>
        </div>
        <table id="table" class="table table-striped table-hover table-bordered">
            <thead>
                <th>id</th>
                <th>First name </th>
                <th>Last Name</th>
                <th>Country</th>
                <th>Subject</th>
                <th>Customer Type</th>
                <th>Register Status </th>
                <th>Action</th>

            </thead>
            <tbody>

            </tbody>

        </table>
    </div>

</body>
<script>


    "use strict"

    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
        onPageLoading();
        //gán sự kiện cho button 
        $("#table").on("click", ".user-sua", onBtnSuaClick);
        $("#table").on("click", ".user-xoa", onBtnXoaClick);
        $("#add-user").on("click", onBtnThemClick);
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        // load table
        getLoadDanhSachUser();
        // gán sự kiệ cho nút 
    }
    // khai báo hàm nút thêm 
    function onBtnThemClick() {
        console.log("đã ấn nút thêm");
        window.location.href = "insertUser.html";
    }
    // khai báo hàm nút sửa 
    function onBtnSuaClick() {
        console.log("đã ấn nút sửa ");
        var vId = $(this).data("user-id");
        console.log(vId);
        window.location.href = "updateUser.html" + "?id=" + vId;
    }
    // khai báo hàm nút xóa 
    function onBtnXoaClick() {
        var vConfirm = confirm("bạn có muốn xóa user");
        var vId = $(this).data("user-id");
        // nếu đồng ý thì . xóa
        if (vConfirm) {
            console.log($(this).data("user-id"));
            // gọi api xóa user theo id 
            deleteUser(vId);
        }
    }


    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function getLoadDanhSachUser() {
        // step 1 : thu thâpj dữ liệu
        // bước 2 : kiểm tra _ bỏ qua 
        // bước 3 : gọi api _
        var vObject = getDisplayApi();
    }
    // gọi api để lấy danh sách 
    function getDisplayApi() {
        // sử dụng công nghệ ajax jquery 
        "use strict"
        $.ajax({
            url: gBASE_URL,
            type: "GET",
            dataType: "json",
            async: true,
            success: function (res) {
                // bước 4 : display in wed
                getShowListUse(res);
            },
            error: function (ajaxContext) {
                alert(ajaxContext.responseText);
            }
        });
    }
    // hiển thị danh sách lên table 
    function getShowListUse(paramObject) {
        "use strict"
        console.log(paramObject);
        var vUseTable = $("#table");
        for (var bI = 0; bI < paramObject.length; bI++) {
            var vobjectTable = paramObject[bI];
            var vRow = $("<tr>").appendTo(vUseTable); // vừa tạo ra hàm row mới.. vừa gắn vào bảng 
            vRow.append($("<td>", { html: vobjectTable.id }))
                .append($("<td>", { html: vobjectTable.firstname }))
                .append($("<td>", { html: vobjectTable.lastname }))
                .append($("<td>", { html: vobjectTable.country }))
                .append($("<td>", { html: vobjectTable.subject }))
                .append($("<td>", { html: vobjectTable.customerType }))
                .append($("<td>", { html: vobjectTable.registerStatus }));
            var bActionCell = $("<td>").appendTo(vRow);
            // tạo nút sửa 
            $("<button>", {
                html: "sửa",
                class: "btn btn-primary user-sua mr-1"
            })
                .data("user-id", vobjectTable.id)
                .appendTo(bActionCell);
            // tạo nút xóa 
            $("<button>", {
                html: "Xóa",
                class: "btn btn-danger user-xoa"
            })
                .data("user-id", vobjectTable.id)
                .appendTo(bActionCell);
        }
    }
    // gọi api xóa người dùng 
    function deleteUser(paramId) {
        $.ajax({
            url: gBASE_URL + paramId,
            type: "DELETE",
            success: xoaThanhCong,
            error: xoaKhongThanhCong
        });
    }
    // khai  báo hàm nếu xóa thành công
    function xoaThanhCong(paramRes) {
        console.log(paramRes);
        alert("đã xóa thành công. ");
        location.reload();
    }
    // khai  báo hàm nếu xóa không thành công
    function xoaKhongThanhCong(paramError) {
        console.log(paramError.status);
        alert("xin lỗi chúng việc xóa đã gặp sự cố. ");
        location.reload();
    }
</script>

</html>